=== debian/changelog ===
strawberry (1.0.12-2) unstable; urgency=medium

  * Fix playlist saving (fixes Upstream #1092)

 -- Peter Blackman <peter@pblackman.plus.com>  Wed, 04 Jan 2023 23:23:00 +0000

strawberry (1.0.12-1) unstable; urgency=medium

  * New upstream release

 -- Peter Blackman <peter@pblackman.plus.com>  Mon, 02 Jan 2023 19:20:20 +0000

strawberry (1.0.11-1) unstable; urgency=medium

  * New upstream version
  * Drop desktop patch (keywords added upstream)
  * Revert build dependency change for Hurd
  * Remove MAINT_APPEND flags (fixes Ubuntu #1997309)

 -- Peter Blackman <peter@pblackman.plus.com>  Fri, 30 Dec 2022 20:17:37 +0000
