=== debian/changelog ===
strawberry (1.0.13-2) unstable; urgency=medium

  * Remove superfluous file in debian folder

 -- Peter Blackman <peter@pblackman.plus.com>  Tue, 10 Jan 2023 15:00:00 +0000

strawberry (1.0.13-1) unstable; urgency=medium

  * New upstream release

 -- Peter Blackman <peter@pblackman.plus.com>  Tue, 10 Jan 2023 12:00:00 +0000
