=== src/CMakeLists.txt ===
--- 
+++ 
@@ -82,9 +82,11 @@
   collection/collectionitemdelegate.cpp
   collection/collectionviewcontainer.cpp
   collection/collectiondirectorymodel.cpp
+  collection/collectionfilteroptions.cpp
   collection/collectionfilterwidget.cpp
   collection/collectionplaylistitem.cpp
   collection/collectionquery.cpp
+  collection/collectionqueryoptions.cpp
   collection/savedgroupingmanager.cpp
   collection/groupbydialog.cpp
   collection/collectiontask.cpp
@@ -412,5 +414,3 @@
 
   settings/settingsdialog.h
   settings/settingspage.h
-  settings/behavioursettingspage.h
-  settings/collectionsettingspage.h
