=== 3rdparty/SPMediaKeyTap/CMakeLists.txt ===
set(SPMEDIAKEY-SOURCES
  SPMediaKeyTap.m
)

set(SPMEDIAKEY-HEADERS
  SPMediaKeyTap.h
)

ADD_LIBRARY(SPMediaKeyTap STATIC
  ${SPMEDIAKEY-SOURCES}
)
