=== ext/gstmoodbar/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(SOURCES gstfastspectrum.cpp gstmoodbarplugin.cpp)

link_directories(
  ${GLIB_LIBRARY_DIRS}
  ${GOBJECT_LIBRARY_DIRS}
  ${GSTREAMER_LIBRARY_DIRS}
  ${GSTREAMER_BASE_LIBRARY_DIRS}
  ${GSTREAMER_AUDIO_LIBRARY_DIRS}
  ${FFTW3_LIBRARY_DIRS}
)

add_library(gstmoodbar STATIC ${SOURCES})

target_include_directories(gstmoodbar SYSTEM PRIVATE
  ${GLIB_INCLUDE_DIRS}
  ${GOBJECT_INCLUDE_DIRS}
  ${GSTREAMER_INCLUDE_DIRS}
  ${GSTREAMER_BASE_INCLUDE_DIRS}
  ${GSTREAMER_AUDIO_INCLUDE_DIRS}
  ${FFTW3_INCLUDE_DIR}
)

target_include_directories(gstmoodbar PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})

target_link_libraries(gstmoodbar PRIVATE
  ${GLIB_LIBRARIES}
  ${GOBJECT_LIBRARIES}
  ${GSTREAMER_LIBRARIES}
  ${GSTREAMER_BASE_LIBRARIES}
  ${GSTREAMER_AUDIO_LIBRARIES}
  ${FFTW3_FFTW_LIBRARY}
  ${QtCore_LIBRARIES}
)
