=== debian/changelog ===
strawberry (1.0.14-1) unstable; urgency=medium

  * New upstream release

 -- Peter Blackman <peter@pblackman.plus.com>  Tue, 17 Jan 2023 15:00:00 +0000
